function UT = NLSE2D_Fsym(U,V,h,s,a,method,BC,l_a,l_h2,a_12,a_6h2)
syms Bx By Bc Dx Dy Dc L;

%Get size of data cube:
sizeu = size(U);

%Initialize Ut and (temp) Laplacian cubes:
UT  = sym(zeros(sizeu));
LAP = sym(zeros(sizeu));

%Make interier indicies:
xin = [2:sizeu(1)-1];
yin = [2:sizeu(2)-1];

%Compute 2D second order CD Laplacian:
LAP(xin,yin) = l_h2*(U(xin+1,yin) + U(xin-1,yin) +...
                     U(xin,yin+1) + U(xin,yin-1) -...
                            4*U(xin,yin));

%Compute boundary conditions on Laplacian:
LAP(1 ,yin)    = l_h2*Dx*U(1 ,yin);
LAP(xin, 1)    = l_h2*Dy*U(xin, 1);
LAP(end,yin)   = l_h2*Dx*U(end,yin);
LAP(xin,end)   = l_h2*Dy*U(xin,end);
LAP(1  ,1)     = l_h2*Dc*U(1  ,1);
LAP(1  ,end)   = l_h2*Dc*U(1  ,end);
LAP(end,1)     = l_h2*Dc*U(end,1);
LAP(end,end)   = l_h2*Dc*U(end,end);

if(method==11)  %CD
   UT(xin,yin) = 1i*(a*LAP(xin,yin) + (a/(h^2))*L.*U(xin,yin));
elseif(method==12)%2SHOC
   UT(xin,yin) = 1i*(-a_12*(LAP(xin+1,yin) + LAP(xin-1,yin) +...
                            LAP(xin,yin+1) + LAP(xin,yin-1) -...
                         12*LAP(xin,yin)) + ...
                      a_6h2*(U(xin+1,yin+1) + U(xin+1,yin-1) +...
                             U(xin-1,yin+1) + U(xin-1,yin-1) -...
                           4*U(xin,yin)) + ...
             (a/(h^2))*L.*U(xin,yin));
end

%Now do boundary conditions on Ut:
UT(1 ,yin)    = l_h2*1i*a*Bx*U(1 ,yin);
UT(xin, 1)    = l_h2*1i*a*By*U(xin, 1);
UT(end,yin)   = l_h2*1i*a*Bx*U(end,yin);
UT(xin,end)   = l_h2*1i*a*By*U(xin,end);
UT(1  ,1)     = l_h2*1i*a*Bc*U(1  ,1);
UT(1  ,end)   = l_h2*1i*a*Bc*U(1  ,end);
UT(end,1)     = l_h2*1i*a*Bc*U(end,1);
UT(end,end)   = l_h2*1i*a*Bc*U(end,end);

clear LAP;
return;
