%Ron Caplan
%Generate stability matrices for 2D and compute G disks.
%Figure 5.2 images display at end of computation.

clear all;
close all;

for(method = 11:12)

BC = 1;
syms h a s 
l_a  = 1/a;    l_h2 = 1/h^2;    
l76  = 7/6;    l_12 = 1/12;   
a_12 = a/12;  a_6h2 = a/(6*h^2);
par  = [];

N = 7;
M = 7;


V  = sym(zeros(N,M));
A  = sym(zeros(N*M,N*M));
U0 = sym(zeros(N,M));

aj=0;
for k=1:M
    for j=1:N
       aj = aj+1; 
       U0(j,k) = 1;   
       U1 = NLSE2D_Fsym(U0,V,h,s,a,method,BC,l_a,l_h2,a_12,a_6h2);
       A(:,aj) = U1(:);
       U0(j,k) = 0;
    end
end

A = simplify(A*(h^2/(a*1i)))
A2 = A;

a2j = 1;
for j=1:N*M
    if(sum([abs(A(j,1:j-1)),abs(A(j,j+1:end))])==0)
        A2(a2j,:) = [];
        A2(:,a2j) = [];
        a2j = a2j-1;        
    end
    a2j = a2j+1;
end
[NM2,NM22] = size(A2);

Gcircles = sym(zeros(NM2,4));


for j=1:NM2   
    Gcircles(j,1) = A2(j,j);
    Gcircles(j,2) = sum([abs(A2(j,1:j-1)),abs(A2(j,j+1:end))]);
    Gcircles(j,3) = A2(j,j) + sum([abs(A2(j,1:j-1)),abs(A2(j,j+1:end))]);
    Gcircles(j,4) = A2(j,j) - sum([abs(A2(j,1:j-1)),abs(A2(j,j+1:end))]);   
end
A2
Gcircles = sym(unique(Gcircles,'rows'))
%Gcircles
L=0;
Bx=1; 
By=1;
Bc=1;
Dx=1;
Dy=1;
Dc=1;
A  = double(sym(eval(A)));
A2 = double(sym(eval(A2)));
figure(method)
spy(A)
axis([1 N*M 1 N*M]);
xlabel(' ');
set(gca,'YTick',[1 floor(N*M/2) N*M]);
set(gca,'XTick',[1 floor(N*M/2) N*M]);
figure(method+10)
spy(A2)
axis([1 NM2 1 NM2]);
xlabel(' ');
set(gca,'YTick',[1 floor(NM2/2) NM2]);
set(gca,'XTick',[1 floor(NM2/2) NM2]);


Gcircles = double(eval(Gcircles));
Gcircles = sym(unique(Gcircles,'rows'))
sym(max(max(abs(double(Gcircles(:,3:4))))))

G12 = 12*sort(unique(Gcircles(:,3:4)))

end

